/*
  Netstumbler 0.3.23 .NS1 native binary file decoder
  creation: SCL (lincomatic@hotmail.com) 20020530

  This code may be freely distributed for personal use.  Commercial
  use is prohibited.
 */
#include <stdio.h>
#include <windows.h>
#include <math.h>
#include <time.h>

// flags
#define FLGF_WEP_ON 0x00000010

int main(int argc,char *argv[])
{
  FILE *ifp = fopen(argv[1],"rb");
  if (ifp) {
    char magic[5];
    magic[4] = 0;
    fread(magic,4,1,ifp);
    printf("magic: %s\n",magic);
    DWORD d;
    fread(&d,4,1,ifp); // ?? = 6

    DWORD apcnt;
    fread(&apcnt,4,1,ifp);
    printf("AP count: %ld\n",apcnt);

    for (int apc=0;apc < apcnt;apc++) {
      BYTE ssidlen;
      fread(&ssidlen,1,1,ifp);
      char ssid[256];
      fread(ssid,ssidlen,1,ifp);
      ssid[ssidlen] = '\0';

      BYTE bssid[6];
      fread(bssid,6,1,ifp);

      printf("************************\n%8d SSID: %s BSSID: %02x:%02x:%02x:%02x:%02x:%02x\n",apc,
	     ssid,bssid[0],bssid[1],bssid[2],bssid[3],bssid[4],bssid[5]);

      LONG signal;
      fread(&signal,4,1,ifp);
      LONG noise;
      fread(&noise,4,1,ifp);
      LONG snr;
      fread(&snr,4,1,ifp);
      DWORD channelbits;
      fread(&channelbits,4,1,ifp);
      DWORD flags;
      fread(&flags,4,1,ifp);
      DWORD beacon;
      fread(&beacon,4,1,ifp);
      printf("%4ld %4ld %4ld %04lx %ld\n",signal,noise,snr,flags,beacon);
      printf("WEP: %s\n",(flags & FLGF_WEP_ON) ? "on" : "off");


      FILETIME ft;
      fread(&ft,sizeof(ft),1,ifp); // first seen
      SYSTEMTIME st;
      FileTimeToSystemTime(&ft,&st);
      printf("first seen: %04d/%02d/%02d %02d:%02d:%02d (GMT)\n",
	      st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);

      fread(&ft,sizeof(ft),1,ifp); // last seen
      FileTimeToSystemTime(&ft,&st);
      printf("last seen: %04d/%02d/%02d %02d:%02d:%02d (GMT)\n",
	      st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);

      double lat,lon;
      fread(&lat,8,1,ifp);
      fread(&lon,8,1,ifp);

      printf("lat: %lf lon: %lf\n",lat,lon);

      DWORD reccount;
      fread(&reccount,4,1,ifp);
      printf("record count: %ld\n",reccount);
      /*dbg
	for (int i=0;i < 50;i++) {
	fread(&d,4,1,ifp);
	printf("%2d %04lx %ld\n",i,d,d);
	}
      */
      for (int i=0;i < (int)reccount;i++) {
	fread(&ft,sizeof(ft),1,ifp); // last seen
	FileTimeToSystemTime(&ft,&st);
	printf("%04d/%02d/%02d %02d:%02d:%02d: ",
	       st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond);
	fread(&signal,4,1,ifp);
	fread(&noise,4,1,ifp);
	fread(&d,4,1,ifp); // ?? flags of some sort
	printf("FLG: %08lx\n",d);
	if (d & 0x00000001) { // what is in the mystery chunk?
	  BYTE mc[60];
	  fread(mc,60,1,ifp);
	}
	printf("%4ld %4ld\n",signal,noise);
      }

      BYTE apncnt;
      fread(&apncnt,1,1,ifp); // terminating NULL or AP name
      if (apncnt) {
	char apname[256];
	fread(apname,apncnt,1,ifp);
	apname[apncnt] = '\0';
	printf("AP Name: %s\n",apname);
      }
    }
    d = ftell(ifp);
    printf("fpos %lx %ld\n",d,d);

    fclose(ifp);
    return 0;
  }

  return 1;
}
  
